Main Page Modules Class Hierarchy Alphabetical List Compound List File List Compound Members

# SoComplexity Class Reference
[Nodes]

The SoComplexity class is a node type which is used to set the tradeoff between quality and performance. More...

`#include <Inventor/nodes/SoComplexity.h>`

Inheritance diagram for SoComplexity:

List of all members.

## Public Types
enum | Type { OBJECT_SPACE = SoComplexityTypeElement::OBJECT_SPACE, SCREEN_SPACE = SoComplexityTypeElement::SCREEN_SPACE, BOUNDING_BOX = SoComplexityTypeElement::BOUNDING_BOX }
## Public Methods
| SoComplexity (void)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
## Static Public Methods
void | initClass (void)
## Public Attributes
SoSFEnum | type
SoSFFloat | value
SoSFFloat | textureQuality
## Protected Methods
virtual | ~SoComplexity ()

## Detailed Description

The SoComplexity class is a node type which is used to set the tradeoff between quality and performance.

By inserting SoComplexity nodes in the scene graph, you can control the accuracy by which complex shapes are rendered and the quality of the texture mapping used for geometry in the scene.

Shape nodes like SoCone, SoSphere, SoCylinder and others, will render with fewer polygons and thereby improve performance, if the complexity value of the traversal state is set to a lower value.

By using the SoComplexity::type field, you may also choose to render the scene graph (or parts of it) just as wireframe bounding boxes. This will improve rendering performance a lot, and can sometimes be used in particular situations where responsiveness is more important than appearance.

Texture mapping can be done in an expensive but attractive looking manner, or in a quick way which doesn't look as appealing by modifying the value of the SoComplexity::textureQuality field. By setting the SoComplexity::textureQuality field to a value of 0.0, you can also turn texturemapping completely off.

## Member Enumeration Documentation

enum SoComplexity::Type

  | The available values for the SoComplexity::type field. Enumeration values:
  OBJECT_SPACE | Use the SoComplexity::value in calculations based on the geometry's size in world-space 3D.
  SCREEN_SPACE | Use the SoComplexity::value in calculations based on the geometry's size when projected onto the rendering area. This is often a good way to make sure that objects are rendered with as low complexity as possible while still retaining their appearance for the user.
  BOUNDING_BOX | Render further geometry in the scene graph as bounding boxes only for superfast rendering.

## Constructor & Destructor Documentation

SoComplexity::SoComplexity | ( | void |  | ) |

| Constructor.

SoComplexity::~SoComplexity | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoComplexity::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode.

void SoComplexity::doAction | ( | SoAction * | action | ) | `[virtual]`

| This function performs the typical operation of a node for any action. Reimplemented from SoNode.

void SoComplexity::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode.

void SoComplexity::getBoundingBox | ( | SoGetBoundingBoxAction * | action | ) | `[virtual]`

| Action method for the SoGetBoundingBoxAction. Calculates bounding box and center coordinates for node and modifies the values of the action to encompass the bounding box for this node and to shift the center point for the scene more towards the one for this node. Nodes influencing how geometry nodes calculates their bounding box also overrides this method to change the relevant state variables. Reimplemented from SoNode.

void SoComplexity::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoNode.

void SoComplexity::pick | ( | SoPickAction * | action | ) | `[virtual]`

| Action method for SoPickAction. Does common processing for SoPickAction action instances. Reimplemented from SoNode.

void SoComplexity::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoNode.

## Member Data Documentation

SoSFEnum SoComplexity::type

| Set rendering type. Default value is SoComplexity::OBJECT_SPACE.

SoSFFloat SoComplexity::value

| Complexity value, valid settings range from 0.0 (worst appearance, best perfomance) to 1.0 (optimal appearance, lowest rendering speed). Default value for the field is 0.5. Note that without any SoComplexity nodes in the scene graph, geometry will render as if there was a SoComplexity node present with SoComplexity::value set to 1.0.

SoSFFloat SoComplexity::textureQuality

| Sets the quality value for texturemapping. Valid range is from 0.0 (texturemapping off, rendering will be much faster for most platforms) to 1.0 (best quality, rendering might be slow). The same value for this field on different platforms can yield varying results, depending on the quality of the underlying rendering hardware. Note that this field influences the behavior of the SoTexture2 node, not the shape nodes. There is an important consequence of this that the application programmer need to know about: you need to insert your SoComplexity node(s) before the SoTexture2 node(s) in the scenegraph for them to have any influence on the textured shapes.

The documentation for this class was generated from the following files:

- SoComplexity.h
- SoComplexity.cpp